"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _open = _interopRequireDefault(require("open"));

var _path = _interopRequireDefault(require("path"));

var _express = _interopRequireDefault(require("express"));

var _webpack = _interopRequireDefault(require("webpack"));

var _httpProxyMiddleware = require("http-proxy-middleware");

var _webpackDevMiddleware = _interopRequireDefault(require("webpack-dev-middleware"));

var _webpackHotMiddleware = _interopRequireDefault(require("webpack-hot-middleware"));

var _connectHistoryApiFallback = _interopRequireDefault(require("connect-history-api-fallback"));

var _webpackServer = _interopRequireDefault(require("../configs/webpack/webpack.server.dev"));

var _webpackClient = _interopRequireDefault(require("../configs/webpack/webpack.client.dev"));

var _get_computed_config = _interopRequireDefault(require("../utils/get_computed_config"));

var _excluded = ["devServer"];
(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
  var app, _yield$get_computed_c, devServer, other_config, server_dev_compiler, client_dev_compiler, listen;

  return _regenerator["default"].wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          app = (0, _express["default"])(); // const runtime_config_path=path.resolve(process.cwd(),config);

          _context2.next = 3;
          return (0, _get_computed_config["default"])();

        case 3:
          _yield$get_computed_c = _context2.sent;
          devServer = _yield$get_computed_c.devServer;
          other_config = (0, _objectWithoutProperties2["default"])(_yield$get_computed_c, _excluded);
          server_dev_compiler = (0, _webpack["default"])((0, _webpackServer["default"])(other_config));
          client_dev_compiler = (0, _webpack["default"])((0, _webpackClient["default"])(other_config));
          _context2.next = 10;
          return new Promise(function (resolve, reject) {
            return server_dev_compiler.watch({}, function (error, stats) {
              return error ? reject(error) : resolve(stats);
            });
          });

        case 10:
          if (other_config.proxy) {
            Object.keys(other_config.proxy).forEach(function (proxy_rule) {
              app.use(proxy_rule, (0, _httpProxyMiddleware.createProxyMiddleware)(other_config.proxy[proxy_rule]));
            });
          }

          require(devServer.server_callback)(app);

          app.use((0, _webpackDevMiddleware["default"])(client_dev_compiler, {}));
          app.use((0, _webpackHotMiddleware["default"])(client_dev_compiler, {
            reload: true
          }));

          if (devServer.history_api_fallback) {
            app.use((0, _connectHistoryApiFallback["default"])());
          }

          listen = app.listen(devServer.port, /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
            var _listen$address, port;

            return _regenerator["default"].wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    if (!devServer.open) {
                      _context.next = 4;
                      break;
                    }

                    _listen$address = listen.address(), port = _listen$address.port;
                    _context.next = 4;
                    return (0, _open["default"])("http://localhost:".concat(port));

                  case 4:
                    ;

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          })));

        case 16:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2);
}))();