"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _miniCssExtractPlugin = _interopRequireDefault(require("mini-css-extract-plugin"));

var _default = function _default(_ref) {
  var isServer = _ref.isServer;
  return [{
    test: /\.(css)$/,
    use: [isServer ? {
      loader: require.resolve("../loaders/ssr_css_module_loader.js")
    } : {
      loader: _miniCssExtractPlugin["default"].loader
    }, {
      loader: "css-loader",
      options: {
        modules: {
          exportOnlyLocals: isServer,
          mode: function mode(resourcePath) {
            if (/\.(global)/.test(resourcePath)) {
              return "global";
            }

            if (/(node_modules)/.test(resourcePath)) {
              return "global";
            }

            ;
            return "local";
          }
        },
        sourceMap: true
      }
    }, {
      loader: "postcss-loader",
      options: {
        postcssOptions: {
          config: true
        },
        sourceMap: true
      }
    }].filter(Boolean)
  }];
};

exports["default"] = _default;