"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = get_webpack_client_dev_config;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _path = _interopRequireDefault(require("path"));

var _webpack = _interopRequireDefault(require("webpack"));

var _webpackMerge = require("webpack-merge");

var _htmlWebpackPlugin = _interopRequireDefault(require("html-webpack-plugin"));

var _miniCssExtractPlugin = _interopRequireDefault(require("mini-css-extract-plugin"));

var _webpack2 = _interopRequireDefault(require("./webpack.basic"));

var _css_loader_config = _interopRequireDefault(require("../rules/css_loader_config"));

var _less_loader_config = _interopRequireDefault(require("../rules/less_loader_config"));

var _scss_loader_config = _interopRequireDefault(require("../rules/scss_loader_config"));

var _file_loader_config = _interopRequireDefault(require("../rules/file_loader_config"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function get_webpack_client_dev_config(_ref) {
  var title = _ref.title,
      define = _ref.define,
      output_path = _ref.output_path,
      client_template = _ref.client_template;
  return (0, _webpackMerge.merge)((0, _webpack2["default"])({
    define: _objectSpread({
      "process.env.isServer": false,
      "process.env.NODE_ENV": "development"
    }, define)
  }), {
    mode: "development",
    entry: ["webpack-hot-middleware/client", client_template],
    output: {
      publicPath: "/",
      path: output_path,
      filename: "[name].js"
    },
    module: {
      rules: [].concat((0, _toConsumableArray2["default"])((0, _css_loader_config["default"])({
        isServer: false
      })), (0, _toConsumableArray2["default"])((0, _less_loader_config["default"])({
        isServer: false
      })), (0, _toConsumableArray2["default"])((0, _scss_loader_config["default"])({
        isServer: false
      })), (0, _toConsumableArray2["default"])((0, _file_loader_config["default"])({
        isServer: false
      })))
    },
    plugins: [new _webpack["default"].HotModuleReplacementPlugin(), new _miniCssExtractPlugin["default"]({
      linkType: "text/css",
      filename: "[name].css"
    }), new _htmlWebpackPlugin["default"]({
      title: title,
      filename: "index.html",
      template: _path["default"].resolve(process.cwd(), "./src/index.html")
    })]
  });
}

;