"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = get_webpack_server_dev_config;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _webpackMerge = require("webpack-merge");

var _webpack = _interopRequireDefault(require("./webpack.basic"));

var _css_loader_config = _interopRequireDefault(require("../rules/css_loader_config"));

var _less_loader_config = _interopRequireDefault(require("../rules/less_loader_config"));

var _scss_loader_config = _interopRequireDefault(require("../rules/scss_loader_config"));

var _file_loader_config = _interopRequireDefault(require("../rules/file_loader_config"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function get_webpack_server_dev_config(_ref) {
  var title = _ref.title,
      define = _ref.define,
      output_path = _ref.output_path,
      server_template = _ref.server_template;
  return (0, _webpackMerge.merge)((0, _webpack["default"])({
    define: _objectSpread({
      "process.env.isServer": true,
      "process.env.NODE_ENV": "development"
    }, define)
  }), {
    target: "node",
    mode: "development",
    entry: server_template,
    output: {
      library: {
        type: "commonjs"
      },
      path: output_path,
      filename: "server.js"
    },
    module: {
      rules: [].concat((0, _toConsumableArray2["default"])((0, _css_loader_config["default"])({
        isServer: true
      })), (0, _toConsumableArray2["default"])((0, _less_loader_config["default"])({
        isServer: true
      })), (0, _toConsumableArray2["default"])((0, _scss_loader_config["default"])({
        isServer: true
      })), (0, _toConsumableArray2["default"])((0, _file_loader_config["default"])({
        isServer: true
      })))
    }
  });
}