import webpack from "webpack";
import {Argument,Option} from "commander";

import get_computed_config from "@/utils/get_computed_config";
import get_webpack_server_build_config from "@/configs/webpack/webpack.server.build";
import get_webpack_client_build_config from "@/configs/webpack/webpack.client.build";

import remove_output_dir from "@/utils/remove_output_dir";

export const test_action_argument1=new Argument("<actions>","动作类型描述").choices(["init","info"]);
export const test_action_option1=new Option("-t,--test_option <string>").default("test_option_value");

export async function build_action(action,{test_option}){
  const {devServer,...other_config}=await get_computed_config();

  const server_build_compiler=webpack(get_webpack_server_build_config(other_config));
  const client_build_compiler=webpack(get_webpack_client_build_config(other_config));

  await remove_output_dir(other_config);
  server_build_compiler.run(()=>{});
  client_build_compiler.run(()=>{});
};