import path from "path";
import spawn from "cross-spawn";
import {Argument,Option} from "commander";

export const test_action_argument1=new Argument("<actions>","动作类型描述").choices(["init","info"]);
export const runtime_config_option=new Option("-c,--config <string>").default("./vision.config.js");

export async function development_action({config}){
  const script_path=path.resolve(__dirname,"../child_process/development_action_process.js");
  await spawn("nodemon",[
    script_path,
    "--watch",process.cwd(),
    "--ignore",path.join(process.cwd(),"./node_modules/"),
    "--ignore",path.join(process.cwd(),"./assets/"),
    "--ignore",path.join(process.cwd(),"./src/"),
  ],{stdio:"inherit"});
};